//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Doctor.Tiy & Anya.Bu."


extern int FastEMA_I=12;
extern int SlowEMA_I=26;
extern int SignalSMA=9;

double     MacdBuffer_I;
double     MacdBuffer_II;
double     MacdBuffer_III;
double     MacdBuffer_IV;
double     MacdBuffer_V;

extern  int Mode_ =1;

extern double TakeProfit = 2500;
extern double StopLoss = 25000;

extern double Lots = 1;
extern double delta=0.0002;

int BuySell, CollBuySell=1; double Tg.Alfa;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

  }
  
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
  
   int cnt, ticket, total;
  
   int TicketBuy, TicketSell;
  
   int limit; int Fractal;
  // int Ticket_Buy, Ticket_Sell;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
      
   limit=Bars-counted_bars; int i=0;
   
MacdBuffer_I=iMA(NULL,0,FastEMA_I,0,Mode_,PRICE_CLOSE,0)-iMA(NULL,0,SlowEMA_I,0,Mode_,PRICE_CLOSE,0);
MacdBuffer_II=iMA(NULL,0,FastEMA_I,0,Mode_,PRICE_CLOSE,1)-iMA(NULL,0,SlowEMA_I,0,Mode_,PRICE_CLOSE,1);
MacdBuffer_III=iMA(NULL,0,FastEMA_I,0,Mode_,PRICE_CLOSE,2)-iMA(NULL,0,SlowEMA_I,0,Mode_,PRICE_CLOSE,2);
MacdBuffer_IV=iMA(NULL,0,FastEMA_I,0,Mode_,PRICE_CLOSE,3)-iMA(NULL,0,SlowEMA_I,0,Mode_,PRICE_CLOSE,3);
MacdBuffer_V=iMA(NULL,0,FastEMA_I,0,Mode_,PRICE_CLOSE,4)-iMA(NULL,0,SlowEMA_I,0,Mode_,PRICE_CLOSE,4); 

  total=OrdersTotal();
   if(total<CollBuySell) 
     {
    // check for long position (BUY) possibility

    if (MacdBuffer_III<-1*delta)
       if (MacdBuffer_III-MacdBuffer_V < 0)
        if (MacdBuffer_III-MacdBuffer_IV < 0)
          if (MacdBuffer_III-MacdBuffer_II < 0)
            if (MacdBuffer_III-MacdBuffer_I < 0)  
 
   
            {
        
         //if (TicketSell>0) 
        
         TicketBuy=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         
         BuySell=1; Tg.Alfa=Close[0]; }
         
      // check for short position (SELL) possibility
  if (MacdBuffer_III > delta)
       if (MacdBuffer_III-MacdBuffer_V > 0)
        if (MacdBuffer_III-MacdBuffer_IV > 0)
          if (MacdBuffer_III-MacdBuffer_II > 0)
            if (MacdBuffer_III-MacdBuffer_I > 0)  
  
            {
  
        
         //if (TicketBuy>0) 
                  
         TicketSell=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
        
         
         BuySell=1; Tg.Alfa=Close[0];}
      
      
   //     
  //    return(0);
    
    
    
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...


if (BuySell == 1) CloseOrderBuySell(total);   

   return(0);
  }
  
    
int CloseOrderBuySell(int total)
{
for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            
           
  if (MacdBuffer_III> delta)
       if (MacdBuffer_III-MacdBuffer_V > 0)
        if (MacdBuffer_III-MacdBuffer_IV > 0)
          if (MacdBuffer_III-MacdBuffer_II > 0)
            if (MacdBuffer_III-MacdBuffer_I > 0)  
  
            {              
                 OrderClose(OrderTicket(),OrderLots(),Bid,30,Violet); // close position
                 
                 BuySell=0; return(0);
                 
                }
           }
         else // go to short position
           {
            // should it be closed?

   if (MacdBuffer_III< -1*delta)
       if (MacdBuffer_III-MacdBuffer_V < 0)
        if (MacdBuffer_III-MacdBuffer_IV < 0)
          if (MacdBuffer_III-MacdBuffer_II < 0)
            if (MacdBuffer_III-MacdBuffer_I < 0)  
     
      {
  
               OrderClose(OrderTicket(),OrderLots(),Ask,30,Violet); // close position
            
               BuySell=0; return(0);

              }
          
           }
        }
     }
 
  return (0);
 
 }     


//+------------------------------------------------------------------+